Imports System.Runtime.InteropServices

' ***************************************************************************
' * LEPCLIB for VisualBasic.NET
' ***************************************************************************

Module LEPCLIB

    ' ***************************************************************************
    ' * Return code
    ' ***************************************************************************

    Public Const LE_FAIL                   = 0
    Public Const LE_SUCCESS                = 1

    ' ***************************************************************************
    ' * Value
    ' ***************************************************************************

    Public Const LE_REMOTE_KEY_0           = 0
    Public Const LE_REMOTE_KEY_1           = 1
    Public Const LE_REMOTE_KEY_2           = 2
    Public Const LE_REMOTE_KEY_3           = 3
    Public Const LE_REMOTE_KEY_4           = 4
    Public Const LE_REMOTE_KEY_5           = 5
    Public Const LE_REMOTE_KEY_6           = 6
    Public Const LE_REMOTE_KEY_7           = 7
    Public Const LE_REMOTE_KEY_8           = 8
    Public Const LE_REMOTE_KEY_9           = 9
    Public Const LE_REMOTE_KEY_A           = 10
    Public Const LE_REMOTE_KEY_B           = 11
    Public Const LE_REMOTE_KEY_C           = 12
    Public Const LE_REMOTE_KEY_D           = 13
    Public Const LE_REMOTE_KEY_E           = 14
    Public Const LE_REMOTE_KEY_F           = 15
    Public Const LE_REMOTE_KEY_LEFT        = 16
    Public Const LE_REMOTE_KEY_RIGHT       = 17
    Public Const LE_REMOTE_KEY_UP          = 18
    Public Const LE_REMOTE_KEY_DOWN        = 19
    Public Const LE_REMOTE_KEY_ENTER       = 20
    Public Const LE_REMOTE_KEY_PAGEUP      = 21
    Public Const LE_REMOTE_KEY_PAGEDOWN    = 22
    Public Const LE_REMOTE_KEY_MENU        = 23
    Public Const LE_REMOTE_KEY_DISPLAY     = 24
    Public Const LE_REMOTE_KEY_TIMECOUNT   = 25
    Public Const LE_REMOTE_KEY_HEXCODE     = 26
    Public Const LE_REMOTE_KEY_DATACODE    = 27
    Public Const LE_REMOTE_KEY_ZOOM        = 27
    Public Const LE_REMOTE_KEY_DELETE      = 28
    Public Const LE_REMOTE_KEY_TOP         = 28
    Public Const LE_REMOTE_KEY_DONTCARE    = 29
    Public Const LE_REMOTE_KEY_BOTTOM      = 29
    Public Const LE_REMOTE_KEY_LOADSAVE    = 30
    Public Const LE_REMOTE_KEY_FIND        = 31
    Public Const LE_REMOTE_KEY_PRINT       = 32
    Public Const LE_REMOTE_KEY_RUN         = 33
    Public Const LE_REMOTE_KEY_STOP        = 34
    Public Const LE_REMOTE_KEY_SHIFTON     = 35
    Public Const LE_REMOTE_KEY_SHIFT       = 128

    Public Const LE_FUNCTION_ONLINE        = 0
    Public Const LE_FUNCTION_DELAY         = 1
    Public Const LE_FUNCTION_TREND         = 2
    Public Const LE_FUNCTION_BERT          = 3
    Public Const LE_FUNCTION_MANUAL        = 4
    Public Const LE_FUNCTION_BUFFER        = 5
    Public Const LE_FUNCTION_PROGRAM       = 6
    Public Const LE_FUNCTION_FLOW          = 7
    Public Const LE_FUNCTION_ECHO          = 8
    Public Const LE_FUNCTION_POLLING       = 9

    Public Const LE_PROTCOL_ASYNC          = 0
    Public Const LE_PROTCOL_SYNC           = 1
    Public Const LE_PROTCOL_HDLC           = 2
    Public Const LE_PROTCOL_PPP            = 3
    Public Const LE_PROTCOL_IRDA           = 4
    Public Const LE_PROTCOL_I2C            = 5
    Public Const LE_PROTCOL_BURST          = 6
    Public Const LE_PROTCOL_CAN            = 7
    Public Const LE_PROTCOL_HSHDLC         = 8

    Public Const LE_DATACODE_ASCII         = 0
    Public Const LE_DATACODE_EBCDIC        = 1
    Public Const LE_DATACODE_EBCDIK        = 2
    Public Const LE_DATACODE_JIS7          = 3
    Public Const LE_DATACODE_JIS8          = 4
    Public Const LE_DATACODE_HEX           = 5
    Public Const LE_DATACODE_EBCD          = 6
    Public Const LE_DATACODE_TRANSCODE     = 7
    Public Const LE_DATACODE_IPARS         = 8
    Public Const LE_DATACODE_BAUDOT        = 9

    Public Const LE_DATABIT_5              = 0
    Public Const LE_DATABIT_6              = 1
    Public Const LE_DATABIT_7              = 2
    Public Const LE_DATABIT_8              = 3

    Public Const LE_PARITY_NONE            = 0
    Public Const LE_PARITY_ODD             = 1
    Public Const LE_PARITY_EVEN            = 2
    Public Const LE_PARITY_MARK            = 3
    Public Const LE_PARITY_SPACE           = 4
    Public Const LE_PARITY_MP              = 5

    Public Const LE_STOPBIT_1              = 0
    Public Const LE_STOPBIT_2              = 1

    Public Const LE_DATAFORMAT_NRZ         = 0
    Public Const LE_DATAFORMAT_NRZI        = 1
    Public Const LE_DATAFORMAT_FM0         = 2
    Public Const LE_DATAFORMAT_FM1         = 3

    Public Const LE_BCC_NONE               = 0
    Public Const LE_BCC_LRC_ODD            = 1
    Public Const LE_BCC_LRC_EVEN           = 2
    Public Const LE_BCC_CRC_16             = 3
    Public Const LE_BCC_CRC_ITUT           = 4
    Public Const LE_BCC_CRC_6              = 5
    Public Const LE_BCC_CRC_12             = 6

    Public Const LE_DATASEQUENCE_LSBFIRST  = 0
    Public Const LE_DATASEQUENCE_MSBFIRST  = 1

    Public Const LE_IFCODE_UNKNOWNM        = 0
    Public Const LE_IFCODE_UNKNOWNS        = 1
    Public Const LE_IFCODE_OPTION          = 2
    Public Const LE_IFCODE_V24             = 3
    Public Const LE_IFCODE_X21             = 4
    Public Const LE_IFCODE_PROBE           = 5
    Public Const LE_IFCODE_RS449           = 6
    Public Const LE_IFCODE_V35             = 7
    Public Const LE_IFCODE_IRDA            = 8
    Public Const LE_IFCODE_I2C             = 9
    Public Const LE_IFCODE_BURST           = 10
    Public Const LE_IFCODE_RS530           = 11
    Public Const LE_IFCODE_CAN             = 32

    Public Const LE_IDLERECORD_OFF         = 0
    Public Const LE_IDLERECORD_100ms       = 1
    Public Const LE_IDLERECORD_10ms        = 2
    Public Const LE_IDLERECORD_1ms         = 3

    Public Const LE_TMSPRECORD_OFF         = 0
    Public Const LE_TMSPRECORD_DHM         = 1
    Public Const LE_TMSPRECORD_HMS         = 2
    Public Const LE_TMSPRECORD_MS10ms      = 3

    Public Const LE_CLOCK_ST1              = 0
    Public Const LE_CLOCK_ST2              = 1
    Public Const LE_CLOCK_RT               = 2
    Public Const LE_CLOCK_AR               = 4

    Public Const LE_FCS_NONE               = 0
    Public Const LE_FCS_16                 = 1
    Public Const LE_FCS_32                 = 2

    Public Const LE_IDLEMODE_MARK          = 0
    Public Const LE_IDLEMODE_FLAG          = 1

    Public Const LE_HDLCFRAME_NONE         = -1
    Public Const LE_HDLCFRAME_SDLC         = 0
    Public Const LE_HDLCFRAME_SDLCX        = 1
    Public Const LE_HDLCFRAME_X25          = 2
    Public Const LE_HDLCFRAME_X25X         = 3
    Public Const LE_HDLCFRAME_LAPD         = 4

    Public Const LE_HDLCPACKET_NONE        = -1
    Public Const LE_HDLCPACKET_X25         = 0
    Public Const LE_HDLCPACKET_LAPD        = 1

    Public Const LE_I2CSIM_SLAVE           = 0
    Public Const LE_I2CSIM_MASTER          = 1

    Public Const LE_MONSTATUS_DATA_VISIBLE = 128

    ' ***************************************************************************
    ' * Structure
    ' ***************************************************************************

    Public Structure LE_TABLE_ELEMENT
        Public length As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16384)> _
        Public character() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16384)> _
        Public flag() As Byte
        Public Sub Initialize()
            ReDim character(16383)
            ReDim flag(16383)
        End Sub
    End Structure

    Public Structure LE_TABLE
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
        Public start() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
        Public length() As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16384)> _
        Public character() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16384)> _
        Public flag() As Byte
        Public Sub Initialize()
            ReDim start(15)
            ReDim length(15)
            ReDim character(16383)
            ReDim flag(16383)
        End Sub
    End Structure

    Public Structure LE_PROGRAM_ELEMENT
        Public length As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=8192)> _
        Public program_step(,) As Byte
        Public Sub Initialize()
            ReDim program_step(511, 15)
        End Sub
    End Structure

    Public Structure LE_PROGRAM
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Public program() As LE_PROGRAM_ELEMENT
        Public Sub Initialize()
            ReDim program(3)
            ReDim program(0).program_step(511, 15)
            ReDim program(1).program_step(511, 15)
            ReDim program(2).program_step(511, 15)
            ReDim program(3).program_step(511, 15)
        End Sub
    End Structure

    Public Structure LE_MONDATA
        Public statusSD As Byte
        Public statusRD As Byte
        Public SD As Byte
        Public RD As Byte
    End Structure

    ' ***************************************************************************
    ' *  Structure of setting analyzer
    ' ***************************************************************************

    Public Structure LE_CONFIG_ASYNC
        Public SpeedSd As Integer               ' // SD speed: 10 times more than actual bps.
        Public SpeedRd As Integer               ' // RD speed: 10 times more than actual bps.
        Public DataCode As Integer              ' // data code: LE_DATACODE (fixed or multiple number)
        Public DataBit As Integer               ' // number of data bit: LE_DATABIT (fixed or multiple number)
        Public Parity As Integer                ' // parity check: LE_PARITY (fixed or multiple number)
        Public StopBit As Integer               ' // number of stop bit: LE_STOPBIT (fixed or multiple number)
        Public DataFormat As Integer            ' // data format: LE_DATAFORMAT (fixed or multiple number)
        Public FrmEndCharCount As Byte          ' // Number of frame end character
        Public FrmEndChar As Byte               ' // Frame end character
        Public FrmEndTime As Byte               ' // Time of receiving frame end
        Public Bcc As Integer                   ' // BCC LE_BCC (fixed or multiple number)
        Public BeginCharCount As Byte           ' // Number of BCC begin character
        Public BeginChar1 As Byte               ' // BCC begin character
        Public BeginChar2 As Byte               ' // 
        Public EndCharCount As Byte             ' // Number of BCC end character
        Public EndChar1 As Byte                 ' // BCC end character
        Public EndChar2 As Byte                 ' // 
        Public ItbCharCount As Byte             ' // Number of ITB character
        Public ItbChar As Byte                  ' // ITB character
        Public Transparent As Byte              ' // Transparent
        Public DleChar As Byte                  ' // DLE character
        Public Sequence As Integer              ' // Sequence: LE_DATASEQUENCE (fixed or multiple number)
    End Structure

    Public Structure LE_CONFIG_SYNC
        Public SpeedSd As Integer               ' // SD speed: 10 times more than actual bps.
        Public SpeedRd As Integer               ' // RD speed: 10 times more than actual bps.
        Public DataCode As Integer              ' // data code: LE_DATACODE (fixed or multiple number)
        Public DataBit As Integer               ' // number of data bit: LE_DATABIT (fixed or multiple number)
        Public Parity As Integer                ' // parity check: LE_PARITY (fixed or multiple number)
        Public Clock As Integer                 ' // clock selection: LE_CLOCK (fixed or multiple number)
        Public DataFormat As Integer            ' // data format: LE_DATAFORMAT (fixed or multiple number)
        Public SynCharCount As Byte             ' // Number of Sync character
        Public SynChar1 As Byte                 ' // Sync character
        Public SynChar2 As Byte                 ' // 
        Public RstChar As Byte                  ' // Sync Reset character
        Public RstRepeat As Byte                ' // Sync Reset character repeat
        Public SuppressCharCount As Byte        ' // Number of suppress character
        Public SuppressChar As Byte             ' // Suppress character
        Public Bcc As Integer                   ' // BCC LE_BCC (fixed or multiple number)
        Public BeginCharCount As Byte           ' // Number of BCC begin character
        Public BeginChar1 As Byte               ' // BCC begin character
        Public BeginChar2 As Byte               ' // 
        Public EndCharCount As Byte             ' // Number of BCC end character
        Public EndChar1 As Byte                 ' // BCC end character
        Public EndChar2 As Byte                 ' // 
        Public ItbCharCount As Byte             ' // Number of ITB character
        Public ItbChar As Byte                  ' // ITB character
        Public Transparent As Byte              ' // Transparent
        Public DleChar As Byte                  ' // DLE character
        Public Sequence As Integer              ' // Sequence: LE_DATASEQUENCE (fixed or multiple number)
    End Structure

    Public Structure LE_CONFIG_HDLC
        Public SpeedSd As Integer               ' // SD speed: 10 times more than actual bps.
        Public SpeedRd As Integer               ' // RD speed: 10 times more than actual bps.
        Public DataCode As Integer              ' // data code:  LE_DATACODE (fixed or multiple number)
        Public Clock As Integer                 ' // clock selection: LE_CLOCK (fixed or multiple number)
        Public DataFormat As Integer            ' // data format: LE_DATAFORMAT (fixed or multiple number)
        Public Fcs As Integer                   ' // FCS LE_FCS (fixed or multiple number)
        Public fFilterSd As Byte                ' // SD monitor addres filter
        Public FilterSdAddr As Byte             ' // SD monitor frame address
        Public fFilterRd As Byte                ' // RD monitor address filer
        Public FilterRdAddr As Byte             ' // RD monitor frame address
        Public IdleMode As Integer              ' // Idle mode: LE_IDLEMODE (fixed or multiple number)
        Public LeadingCount As Byte             ' // number of leading flag
        Public FrameProtocol As Integer         ' // Frame translation protocol: LE_HDLCFRAME (fixed or multiple number)
        Public PacketProtocol As Integer        ' // Packet translation protocol: LE_HDLCPACKET (fixed or multiple number)
    End Structure

    Public Structure LE_CONFIG_PPP
        Public SpeedSd As Integer               ' // SD speed: 10 times more than actual bps.
        Public SpeedRd As Integer               ' // RD speed: 10 times more than actual bps.
        Public DataCode As Integer              ' // data code:  LE_DATACODE (fixed or multiple number)
        Public Suppress As Byte                 ' // Flag character suppress
        Public Fcs As Integer                   ' // FCS LE_FCS (fixed or multiple number)
    End Structure

    Public Structure LE_CONFIG_IRDA
        Public Speed As Integer                 ' // Transferring speed is 10 times more than actual bps.
        Public DataCode As Integer              ' // data code  LE_DATACODE (fixed or multiple number)
        Public Suppress As Byte                 ' // Flag character suppress
    End Structure

    Public Structure LE_CONFIG_I2C
        Public Speed As Integer                 ' // Transferring speed is 10 times more than actual bps.
        Public DataCode As Integer              ' // data code  LE_DATACODE (fixed or multiple number)
        Public I2cSim As Integer                ' // I2C Simulation mode LE_I2CSIM (fixed or multiple number)
        Public f10BitAddr As Byte               ' // 10 bit address
        Public SlaveAddr As Integer             ' // Slave address
    End Structure

    Public Structure LE_CONFIG_BURST
        Public DataCode As Integer              ' // data code  LE_DATACODE (fixed or multiple number)
        Public DataBit As Integer               ' // number of data bit: LE_DATABIT (fixed or multiple number)
        Public Parity As Integer                ' // Parity check: LE_PARITY (fixed or multiple number)
        Public FrmEndCharCount As Byte          ' // Frame end character count
        Public FrmEndChar As Byte               ' // Frame end character
        Public FrmEndTime As Byte               ' // Frame end time
        Public Sequence As Integer              ' // Sequence LE_DATASEQUENCE (fixed or multiple number)
    End Structure

    Public Structure LE_ONLINESETUP
        Public AutoConfig As Integer            ' // Set Auto-Configuration.
    End Structure

    Public Structure LE_MANUALSETUP
        Public Delay As Integer                 ' // Set the transmission interval between characters in msec.
        Public Idle As Integer                  ' // Set the interval of data transmission repeatedly in msec.
        Public Repeat As Byte                   ' // Set whether using the repeat mode or not.
    End Structure

    Public Structure LE_PROGRAMSETUP
        Public no As Byte                       ' // Set which program to use in the Program mode.
    End Structure

    Public Structure LE_SETUP
        Public Func As Integer
        Public Protocol As Integer
        Public Idle As Integer
        Public Tmsp As Integer
        Public Async As LE_CONFIG_ASYNC
        Public Sync As LE_CONFIG_SYNC
        Public Hdlc As LE_CONFIG_HDLC
        Public Ppp As LE_CONFIG_PPP
        Public Irda As LE_CONFIG_IRDA
        Public I2c As LE_CONFIG_I2C
        Public Burst As LE_CONFIG_BURST
        Public Online As LE_ONLINESETUP
        Public Manual As LE_MANUALSETUP
        Public program As LE_PROGRAMSETUP
    End Structure

    ' ***************************************************************************
    ' * Function
    ' ***************************************************************************
    Declare Function LEGetDllVersion Lib "LEPCLIB.dll" (ByRef version As Integer) As Integer
    Declare Function LEConnect Lib "LEPCLIB.dll" (ByVal com As String) As Integer
    Declare Function LEDisconnect Lib "LEPCLIB.dll" () As Integer
    Declare Function LEStartMeasure Lib "LEPCLIB.dll" () As Integer
    Declare Function LEStopMeasure Lib "LEPCLIB.dll" () As Integer
    Declare Function LEEmulationKey Lib "LEPCLIB.dll" (ByVal code As Integer) As Integer
    Declare Function LEGetSetup Lib "LEPCLIB.dll" (ByRef setup As LE_SETUP) As Integer
    Declare Function LESetSetup Lib "LEPCLIB.dll" (ByRef setup As LE_SETUP) As Integer
    Declare Function LEGetTable Lib "LEPCLIB.dll" (ByRef table As LE_TABLE) As Integer
    Declare Function LESetTable Lib "LEPCLIB.dll" (ByRef table As LE_TABLE) As Integer
    Declare Function LEGetTableElement Lib "LEPCLIB.dll" (ByRef table As LE_TABLE_ELEMENT, ByVal number As Integer) As Integer
    Declare Function LESetTableElement Lib "LEPCLIB.dll" (ByRef table As LE_TABLE_ELEMENT, ByVal number As Integer) As Integer
    Declare Function LEGetProgram Lib "LEPCLIB.dll" (ByRef program As LE_PROGRAM) As Integer
    Declare Function LESetProgram Lib "LEPCLIB.dll" (ByRef program As LE_PROGRAM) As Integer
    Declare Function LEGetProgramElement Lib "LEPCLIB.dll" (ByRef program As LE_PROGRAM_ELEMENT, ByVal number As Integer) As Integer
    Declare Function LESetProgramElement Lib "LEPCLIB.dll" (ByRef program As LE_PROGRAM_ELEMENT, ByVal number As Integer) As Integer
    Declare Function LEGetMonitorData Lib "LEPCLIB.dll" (ByRef mondata As LE_MONDATA, ByRef length As Integer) As Integer
    Declare Function LEGetMonitorDataOffset Lib "LEPCLIB.dll" (ByRef mondata As LE_MONDATA, ByRef length As Integer, ByVal offset As Integer) As Integer

End Module
